#if !defined(TS_HRW_IMPORT_INCLUDED_)
#define TS_HRW_IMPORT_INCLUDED_

// Fehler
// Error codes DLL
#define TSHRW_NO_ERROR                    0
#define TSHRW_PORT_OEFFNEN                1
#define TSHRW_TIMEOUT_UNGUELTIG           2
#define TSHRW_PORTHANDLE_UNGUELTIG        3
#define TSHRW_TIMEOUT                     4
#define TSHRW_BUFFER_ZU_KLEIN             5
#define TSHRW_BUFFERGROESSE_FALSCH        6
#define TSHRW_FALSCHE_PARAMETER           7
#define TSHRW_KEINE_SENDEDATEN            8
#define TSHRW_KEINE_EMPFANGSDATEN         9
#define TSHRW_CHECKSUMMENFEHLER           10
#define TSHRW_KEINE_KOMMUNIKATION         11
#define TSHRW_CHECKBUFFER_LEER            12
#define TSHRW_MODE_UNGUELTIG              13
#define TSHRW_BEFEHL_NICHT_ERLAUBT        14 
#define TSHRW_BLOCKNR_UNGUELTIG           15
#define TSHRW_KOMMANDOFEHLER              16
#define TSHRW_RF_IS_OFF                   17

#define TSHRW_DC3                         19 //0x13
#define TSHRW_DC4                         20 //0x14
#define TSHRW_NACK                        21 //0x15
#define TSHRW_SYNC                        22 //0x16
#define TSHRW_ETB                         23 //0x17
#define TSHRW_CANCEL                      24 //0x18
#define TSHRW_EM                          25 //0x19

// Error codes Leser
#define TSHRW_UNBEKANNTES_KOMMANDO                   TSHRW_CANCEL
#define TSHRW_DATENANZAHL                            TSHRW_DC4
#define TSHRW_KOLLISION                              TSHRW_ETB
#define TSHRW_NO_TAG                                 TSHRW_NACK
#define TSHRW_NO_VALUE                               TSHRW_DC3

// Error codes Leser
#define TSHRW_ISO_ERROR_COMMAND_NOT_SUPPORTED        0x20
#define TSHRW_ISO_ERROR_COMMAND_NOT_RECOGNIZED       0x21
#define TSHRW_ISO_ERROR_COMMANDOPTION_NOT_SUPPORTED  0x22
#define TSHRW_ISO_ERROR_NO_INFO                      0x23
#define TSHRW_ISO_ERROR_BLOCK_NOT_AVAILABLE          0x24
#define TSHRW_ISO_ERROR_BLOCK_ALREADY_LOCKED         0x25
#define TSHRW_ISO_ERROR_CANT_CHANGE_LOCKED_BLOCK     0x26
#define TSHRW_ISO_ERROR_NOT_SUCCESSFULLY_PROGRAMMED  0x27
#define TSHRW_ISO_ERROR_NOT_SUCCESSFULLY_LOCKED      0x28
#define TSHRW_ISO_ERROR_UNKNOWN                      0x29
#define TSHRW_ISO_FEHLERLAENGE_NICHT_KORREKT         0x2A
#define TSHRW_ISO_UNBEKANNTER_TAG                    0x2B

// Defines zum anhngen falls kein UID
#define _MYD1    0x100
#define _ICODE2  0x200
#define _TAGIT2  0x400
#define _E_MARIN 0x800
#define _STM     0x1000
#define _FUJITSU 0x2000
#define _KSW     0x4000

// ISO Request flags
#define ISO15693_TWO_SUBCARRIER_FLAG    0x01
#define ISO15693_HIGH_DATARATE_FLAG     0x02
#define ISO15693_INVENTORY_FLAG         0x04
#define ISO1569_PROTOKOLL_EXTENSION     0x08 

// ISO Request non inventory table
#define ISO15693_SELECT_FLAG            0x10
#define ISO15693_ADDRESS_FLAG           0x20
#define ISO15693_OPTION_FLAG            0x40

// ISO Request inventory table
#define ISO15693_AFI_FLAG               0x10
#define ISO15693_SINGLE_SLOT_FLAG       0x20
//#define OPTION_FLAG    0x40 (gilt fr inventory und non inventory table)

// Manufacturer Codes
#define ISO15693_MFG_CODE_STM           0x02   // ST Microelectronics
#define ISO15693_MFG_CODE_PHILIPS       0x04   // Philips
#define ISO15693_MFG_CODE_INFINEON      0x05   // Infineon
#define ISO15693_MFG_CODE_TI            0x07   // Texas Instruments
#define ISO15693_MFG_CODE_FUJITSU       0x08   // Fujitsu
#define ISO15693_MFG_CODE_INSIDE        0x12   // Inside Technology France
#define ISO15693_MFG_CODE_ATMEL         0x15   // ATMEL France
#define ISO15693_MFG_CODE_EM            0x16   // Electro Marin
#define ISO15693_MFG_CODE_KSW           0x17   // KSW Mikrotec
#define ISO15693_MFG_CODE_SIC           0x39   // Silicon Craft Thailand
#define ISO15693_MFG_CODE_HID           0x3D   // HID Global USA

#define IGNORE_AUTOMATIC_FLAGS          0x8000


// Parameter fr Mifare Kommandos
#define MIFARE_AUTH_A                   0x00
#define MIFARE_AUTH_B                   0x01

#define DEC_VALUE                       0x00
#define INC_VALUE                       0x01

// Parameter fr SAM Access
#define KEY_TYPE_AES128                 0x0000
#define KEY_TYPE_AES192                 0x0001
#define KEY_TYPE_AES256                 0x0002
#define KEY_TYPE_DES                    0x0003
#define KEY_TYPE_2KTDES                 0x0004
#define KEY_TYPE_3KTDES                 0x0005
#define KEY_TYPE_MIFARE                 0x0006
#define SAM_MODE_AV1                    0x0100

#define DIV_MODE_DESFIRE       0x0000U /**< DESFire Key Diversification. */
#define DIV_MODE_MIFARE_PLUS   0x0001U /**< MIFARE Plus Key Diversification. */
#define DIV_MODE_MASK          0x00FFU /**< Bitmask for diversification Mode. */
#define DIV_OPTION_2KTDES_FULL 0x0000U /**< Option for 2K3DES full-key diversification (only with #PH_CRYPTOSYM_DIV_MODE_DESFIRE). */
#define DIV_OPTION_2KTDES_HALF 0x8000U /**< Option for 2K3DES half-key diversification (only with #PH_CRYPTOSYM_DIV_MODE_DESFIRE). */



// Rckgabewerte
#define TSHRW_RETVAL_ERROR                -1
#define TSHRW_RETVAL_OK                   0

#ifdef __cplusplus
extern "C"
{
#endif

typedef int (__stdcall * TSHRW_TRACEFCT)(int handle, LPCTSTR str);

#ifdef _EXPORT
#define _DECL __declspec(dllexport)
#else
#ifdef _HRW_LIB
#define _DECL
#else
#define _DECL __declspec(dllimport)
#endif
#endif

_DECL int __stdcall TSHRW_LibVersion(void);
_DECL int __stdcall TSHRW_IsVirtualComInstalled(void);

_DECL int __stdcall TSHRW_CountAllDevices();
_DECL int __stdcall TSHRW_ListAllDeviceNames(char* NamenListe, int nBufferSize);
_DECL int __stdcall TSHRW_ListAllDeviceNamesEx(char* NamenListe, int nBufferSize);
_DECL int __stdcall TSHRW_GetAvailablePorts(char* NamenListe, int nBufferSize);

_DECL int __stdcall TSHRW_LanListAllDeviceNames(char* NamenListe, int nBufferSize);
_DECL int __stdcall TSHRW_LanConfigListDevices(char* Buffer, int nBufferSize);

_DECL int __stdcall TSHRW_LanChangeIPAddress(LPCTSTR OldAddress, LPCTSTR NewAddress, LPCTSTR IPMask);
_DECL int __stdcall TSHRW_LanIsDeviceAvailable(LPCTSTR Address);

_DECL int __stdcall TSHRW_LanConfigOpen(LPCTSTR strName);
_DECL int __stdcall TSHRW_LanConfigGet(int nHandle, int RecordNr,       BYTE * pData, int Len);
_DECL int __stdcall TSHRW_LanConfigSet(int nHandle, int RecordNr, const BYTE * pData,int Len);
_DECL int __stdcall TSHRW_LanConfigClose(int nHandle,int Reset);

_DECL int __stdcall TSHRW_HIDConfigRead(int PortHandle, BYTE * pSendBuf, int SendBufLen,BYTE * pRecvBuf, int RecvBufLen);
_DECL int __stdcall TSHRW_HIDConfigWrite(int PortHandle, BYTE * pSendBuf, int SendBufLen);

_DECL int __stdcall TSHRW_BT_SetPin (int PortHandle,const char * Pin);
_DECL int __stdcall TSHRW_BT_GetPin (int PortHandle,char * Pin);
_DECL int __stdcall TSHRW_BT_SetLocalName(int PortHandle, const char * LocalName);
_DECL int __stdcall TSHRW_BT_GetLocalName(int PortHandle, char * LocalName);
_DECL int __stdcall TSHRW_BT_GetLocalBTAddr(int PortHandle, BYTE * LocalAddr);
_DECL int __stdcall TSHRW_BT_SetOperationMode(int PortHandle, int Mode);
_DECL int __stdcall TSHRW_BT_GetOperationMode(int PortHandle, int * pMode);
_DECL int __stdcall TSHRW_BT_SetValidPorts(int PortHandle, int Ports);
_DECL int __stdcall TSHRW_BT_GetValidPorts(int PortHandle, int * pPorts);
_DECL int __stdcall TSHRW_BT_SetEventFilter(int PortHandle, int Filter);
_DECL int __stdcall TSHRW_BT_GetEventFilter(int PortHandle, int * pFilter);
_DECL int __stdcall TSHRW_BT_SetDeviceClass(int PortHandle, int DevClass);
_DECL int __stdcall TSHRW_BT_ChangeUARTSpeed(int PortHandle, int SpeedIdx);

_DECL int __stdcall TSHRW_BT_ListAllDeviceNames(char* Buffer, int nBufferSize);
_DECL int __stdcall TSHRW_BT_Search (int PortHandle, BYTE * DeviceList, int nBufferSize, int Timeout , DWORD ClassFilter);
_DECL int __stdcall TSHRW_BT_Connect(int PortHandle, BYTE * Device, BYTE RemotePortNr, int Timeout);
_DECL int __stdcall TSHRW_BT_CheckConnection(int PortHandle);
_DECL int __stdcall TSHRW_BT_Disconnect(int PortHandle);

_DECL int __stdcall TSHRW_OpenPort(LPCTSTR Name,int Baudrate,int Timeout);
_DECL int __stdcall TSHRW_ClosePort(int handle);
_DECL int __stdcall TSHRW_KeepAppActive(int handle,int bActive);

_DECL int __stdcall TSHRW_SetTrace(TSHRW_TRACEFCT fct);

_DECL int __stdcall TSHRW_SetReaderAdresse(int handle,int Adresse);
_DECL int __stdcall TSHRW_DeviceVersion(int PortHandle, BYTE * pBuffer, int BufLen);
_DECL int __stdcall TSHRW_IsUSB(int handle);
_DECL int __stdcall TSHRW_SetBaudrate(int handle, int Baudrate, int ParityMode);
_DECL int __stdcall TSHRW_SetReaderMode(int handle,int mode);
_DECL int __stdcall TSHRW_SetRF(int handle,int OnOff);
_DECL int __stdcall TSHRW_SetIO(int handle,int Maske, int OutWert);
_DECL int __stdcall TSHRW_ReadIO(int handle);
_DECL int __stdcall TSHRW_GetLastError(int handle);

_DECL int __stdcall TSHRW_ReadSerialNumber(int handle, BYTE * pSerial, int Buflen);
_DECL int __stdcall TSHRW_SetConfig(int handle,BYTE * pConfig, int ConfigLen);
_DECL int __stdcall TSHRW_GetConfig(int handle,BYTE * pConfig, int ConfigLen);
_DECL int __stdcall TSHRW_SetDefault(int handle);

_DECL int __stdcall TSHRW_GetActivationContext(int handle, char * pData, int Len);
_DECL int __stdcall TSHRW_WriteActivationContext(int handle, const char * pData, int Len);
_DECL int __stdcall TSHRW_ReadCounter(int handle, int * pCounter);
_DECL int __stdcall TSHRW_DecrementCounter(int handle, int * pNewCounter);
_DECL int __stdcall TSHRW_GetDaysRemain(int handle, int * pDaysRemain);
_DECL int __stdcall TSHRW_UpdateDaysRemain(int handle, int * pDaysRemain);

_DECL int __stdcall TSHRW_SetCommunicationMode(int handle, int Mode);

_DECL int __stdcall TSHRW_RawWrite(int handle,BYTE * pBuffer, int BufLen);
_DECL int __stdcall TSHRW_RawRead(int handle,BYTE * pBuffer, int BufLen);
_DECL int __stdcall TSHRW_Transfer(int PortHandle, BYTE * pSendBuf, int SendBufLen,BYTE * pRecvBuf, int RecvBufLen);

_DECL int __stdcall TSHRW_ReadRegister(int handle, int Register, BYTE *pVal);
_DECL int __stdcall TSHRW_WriteRegister(int handle, int Register, BYTE Val);

_DECL int __stdcall TSHRW_ReadEEProm(int handle, int StartAdresse, BYTE * pData, int Len);
_DECL int __stdcall TSHRW_WriteEEProm(int handle, int StartAdresse, const BYTE * pData, int Len);

_DECL int __stdcall TSHRW_ISO_Inventory(int handle,BYTE * pBuffer,int BufLen,int nRequestFlag);
_DECL int __stdcall TSHRW_ISO_InventoryAFI(int handle,BYTE * pBuffer,int BufLen,int nRequestFlag,int AFI);
_DECL int __stdcall TSHRW_ISO_GetSystemInfo(int handle,BYTE * pBuffer,int BufLen, BYTE * pUID, int UIDLen,int nRequestFlag);
_DECL int __stdcall TSHRW_ISO_ReadSingleBlock(int handle,int nBlock,BYTE * pBuffer,int BufLen,BYTE * pUID,int UIDLen,int nRequestFlag);
_DECL int __stdcall TSHRW_ISO_ReadMultipleBlocks(int handle,int nFirstBlock,int nNumberOfBlocks,BYTE * pBuffer,int BufLen,BYTE * pUID,int UIDLen,int nRequestFlag);
_DECL int __stdcall TSHRW_ISO_WriteSingleBlock(int handle,int nBlock,BYTE * pBuffer,int BufLen,BYTE * pUID,int UIDLen,int nRequestFlag);
_DECL int __stdcall TSHRW_ISO_SetAirProtokoll(int handle,int nAirSettings);
_DECL int __stdcall TSHRW_ISO_GetAirProtokoll(int handle,int * nAirSettings);
_DECL int __stdcall TSHRW_ISO_GetTagInfo(int handle,BYTE * pUID, int UIDLen,int* BlockAnzahl,int* BytesProBlock,int* MfgCode,int nRequestFlag);
_DECL int __stdcall TSHRW_ISO_LockBlock(int handle,int nBlock,BYTE * pUID,int UIDLen,int nRequestFlag);
_DECL int __stdcall TSHRW_ISO_StayQuiet(int handle,BYTE * pUID,int UIDLen,int nRequestFlag);
_DECL int __stdcall TSHRW_ISO_Select(int handle,BYTE * pUID,int UIDLen,int nRequestFlag);
_DECL int __stdcall TSHRW_ISO_ResetToReady(int handle,BYTE * pUID,int UIDLen,int nRequestFlag);
_DECL int __stdcall TSHRW_ISO_GetMultipleBlockSecurityStatus(int handle,int nFirstBlock,int nNumberOfBlocks,BYTE * pBuffer,int BufLen,BYTE * pUID,int UIDLen,int nRequestFlag);
_DECL int __stdcall TSHRW_ISO_WriteAFI(int handle,int AFI,BYTE * pUID,int UIDLen,int nRequestFlag);
_DECL int __stdcall TSHRW_ISO_LockAFI(int handle,BYTE * pUID,int UIDLen,int nRequestFlag);
_DECL int __stdcall TSHRW_ISO_WriteDSFID(int handle,int DSFID,BYTE * pUID,int UIDLen,int nRequestFlag);
_DECL int __stdcall TSHRW_ISO_LockDSFID(int handle,BYTE * pUID,int UIDLen,int nRequestFlag);
_DECL int __stdcall TSHRW_ISO_RawRequest(int handle,int nRequestFlag, int nKommando, BYTE * pParam, int nParamLen, BYTE * pData, int nDataLen,BYTE * pReceive, int nReceiveLen);

_DECL int __stdcall TSHRW_WriteTiming(int handle,int nTiming);
_DECL int __stdcall TSHRW_SetComparator(int handle,BYTE * pParam, int nParamLen);

_DECL int __stdcall TSHRW_Mifare_Request(int handle,WORD *pATQA);
_DECL int __stdcall TSHRW_Mifare_RequestAll(int handle,WORD *pATQA);
_DECL int __stdcall TSHRW_Mifare_Select(int handle, BYTE * pUID, int nUIDLen, BYTE * pSAK);
_DECL int __stdcall TSHRW_Mifare_SelectUID(int handle, BYTE * pUID, int nUIDLen, BYTE * pSAK);
_DECL int __stdcall TSHRW_Mifare_Halt(int handle);
_DECL int __stdcall TSHRW_MifareSetKey(int handle, int KeyType, int nAdresse, BYTE * pKey, int nKeyLen);
_DECL int __stdcall TSHRW_MifareAuthenticate(int handle, BYTE * pUID, int nUIDLen, int KeyType, int nAdresse, int BlockNr);
_DECL int __stdcall TSHRW_MifareAuthenticateDirect(int handle, BYTE * pUID, int nUIDLen, int KeyType, BYTE * pKey, int nKeyLen, int BlockNr);
_DECL int __stdcall TSHRW_MifareRead       (int handle, int BlockNr, BYTE * pData, int nDataLen);
_DECL int __stdcall TSHRW_MifareWrite      (int handle, int BlockNr, BYTE * pData, int nDataLen);
_DECL int __stdcall TSHRW_MifareGetValue   (int handle, int BlockNr, int *pValue);
_DECL int __stdcall TSHRW_MifareSetValue   (int handle, int BlockNr, int Value);
_DECL int __stdcall TSHRW_MifareChangeValue(int handle, int BlockNr, int Richtung, int Differenz);
_DECL int __stdcall TSHRW_ISO14443SetCID   (int handle, int CID);
_DECL int __stdcall TSHRW_ISO14443Rats     (int handle, BYTE * pData, int  MaxDataLen);
_DECL int __stdcall TSHRW_ISO14443PPS      (int handle, int Speed);
_DECL int __stdcall TSHRW_ISO14443Transmit (int handle, BYTE *pSendData, int nSendLen, BYTE * pRecvData, int RecvLen);

_DECL int __stdcall TSHRW_SAM_Transmit     (int handle, BYTE *pSendData, int nSendLen, BYTE * pRecvData, int RecvLen);
_DECL int __stdcall TSHRW_SAM_AuthenticatHost(int handle, int KeyType, int KeyNrSam, BYTE * pKey, int KeyLen);
_DECL int __stdcall TSHRW_SAM_SwitchToAV2  (int handle, int KeyType, int KeyNrSam, BYTE * pKey, int KeyLen);
_DECL int __stdcall TSHRW_SAM_GetType      (int handle);
_DECL int __stdcall TSHRW_SAM_GetVersion   (int handle, BYTE * pRecvData, int RecvLen);

_DECL int __stdcall TSHRW_CryptoInit();

_DECL int __stdcall TSHRW_WriteParam(int handle,BYTE * pBuffer, int BufLen);
_DECL int __stdcall TSHRW_ReadParam(int handle,BYTE * pBuffer, int BufLen);
_DECL int __stdcall TSHRW_WritePrefix(int handle,BYTE * pBuffer, int BufLen);
_DECL int __stdcall TSHRW_ReadPrefix(int handle,BYTE * pBuffer, int BufLen);
_DECL int __stdcall TSHRW_WriteSuffix(int handle,BYTE * pBuffer, int BufLen);
_DECL int __stdcall TSHRW_ReadSuffix(int handle,BYTE * pBuffer, int BufLen);
_DECL int __stdcall TSHRW_WriteTermix(int handle,BYTE * pBuffer, int BufLen);
_DECL int __stdcall TSHRW_ReadTermix(int handle,BYTE * pBuffer, int BufLen);
_DECL int __stdcall TSHRW_WritePostcode(int handle,BYTE * pBuffer, int BufLen);
_DECL int __stdcall TSHRW_ReadPostcode(int handle,BYTE * pBuffer, int BufLen);
_DECL int __stdcall TSHRW_WriteReadModeParam(int handle,BYTE * pBuffer, int BufLen);
_DECL int __stdcall TSHRW_ReadReadModeParam(int handle,BYTE * pBuffer, int BufLen);
_DECL int __stdcall TSHRW_WriteMifareKey(int handle, int KeyType, BYTE * pKey, int KeyLen);

#ifdef __cplusplus
}
#endif

#endif // TS_HRW_IMPORT_INCLUDED_
