#if !defined(TS_HRW_IMPORT_INCLUDED_)
#define TS_HRW_IMPORT_INCLUDED_

// Fehler
// Error codes DLL
#define TSHRW_NO_ERROR                    0
#define TSHRW_PORT_OEFFNEN                1
#define TSHRW_TIMEOUT_UNGUELTIG           2
#define TSHRW_PORTHANDLE_UNGUELTIG        3
#define TSHRW_TIMEOUT                     4
#define TSHRW_BUFFER_ZU_KLEIN             5
#define TSHRW_BUFFERGROESSE_FALSCH        6
#define TSHRW_FALSCHE_PARAMETER           7
#define TSHRW_KEINE_SENDEDATEN            8
#define TSHRW_KEINE_EMPFANGSDATEN         9
#define TSHRW_CHECKSUMMENFEHLER           10
#define TSHRW_KEINE_KOMMUNIKATION         11
#define TSHRW_CHECKBUFFER_LEER            12
#define TSHRW_MODE_UNGUELTIG              13
#define TSHRW_BEFEHL_NICHT_ERLAUBT        14 
#define TSHRW_BLOCKNR_UNGUELTIG           15
#define TSHRW_KOMMANDOFEHLER              16
#define TSHRW_RF_IS_OFF                   17
#define TSHRW_NULL_POINTER                18

#define TSHRW_DC3                         19 //0x13
#define TSHRW_DC4                         20 //0x14
#define TSHRW_NACK                        21 //0x15
#define TSHRW_SYNC                        22 //0x16
#define TSHRW_ETB                         23 //0x17
#define TSHRW_CANCEL                      24 //0x18
#define TSHRW_EM                          25 //0x19
#define TSHRW_MORE_DATA                   32 //0x20

// Error codes Leser
#define TSHRW_UNBEKANNTES_KOMMANDO                   TSHRW_CANCEL
#define TSHRW_DATENANZAHL                            TSHRW_DC4
#define TSHRW_KOLLISION                              TSHRW_ETB
#define TSHRW_NO_TAG                                 TSHRW_NACK
#define TSHRW_NO_VALUE                               TSHRW_DC3

// Error codes Leser
#define TSHRW_ISO_ERROR_COMMAND_NOT_SUPPORTED        0x20
#define TSHRW_ISO_ERROR_COMMAND_NOT_RECOGNIZED       0x21
#define TSHRW_ISO_ERROR_COMMANDOPTION_NOT_SUPPORTED  0x22
#define TSHRW_ISO_ERROR_NO_INFO                      0x23
#define TSHRW_ISO_ERROR_BLOCK_NOT_AVAILABLE          0x24
#define TSHRW_ISO_ERROR_BLOCK_ALREADY_LOCKED         0x25
#define TSHRW_ISO_ERROR_CANT_CHANGE_LOCKED_BLOCK     0x26
#define TSHRW_ISO_ERROR_NOT_SUCCESSFULLY_PROGRAMMED  0x27
#define TSHRW_ISO_ERROR_NOT_SUCCESSFULLY_LOCKED      0x28
#define TSHRW_ISO_ERROR_UNKNOWN                      0x29
#define TSHRW_ISO_FEHLERLAENGE_NICHT_KORREKT         0x2A
#define TSHRW_ISO_UNBEKANNTER_TAG                    0x2B
#define TSHRW_ISO_ERROR_FRAMING                      0x2C

// Error codes Desfire
#define DesfireCode(Code)                            (0x10000 + Code)  // identifier for Desfire status/error
// Desfire TCL errors, generated by card
#define TSHRW_DESFIRE_NO_CHANGES_DONE                DesfireCode (0x0C) // "No changes done";
#define TSHRW_DESFIRE_OUT_OF_EEPROM_ERROR            DesfireCode (0x0E) // "Internal error, insufficient memory to complete operation";
#define TSHRW_DESFIRE_ILLEGAL_COMMAND_CODE           DesfireCode (0x1C) // "Command code not supported";
#define TSHRW_DESFIRE_INTEGRITY_ERROR                DesfireCode (0x1E) // "Integrity error, CRC or MAC does not match data / Padding bytes not valid"
#define TSHRW_DESFIRE_NO_SUCH_KEY                    DesfireCode (0x40) // "Invalid Key number specified";
#define TSHRW_DESFIRE_INVALID_LENGTH                 DesfireCode (0x7E) // "Internal error, length of Command string invalid";
#define TSHRW_DESFIRE_PERMISSION_DENIED              DesfireCode (0x9D) // "Current config/status does not allow the requested command";
#define TSHRW_DESFIRE_INVALID_PARAMETER_VALUE        DesfireCode (0x9E) // "Internal error, value of the parameter invalid";
#define TSHRW_DESFIRE_APPLICATION_NOT_FOUND          DesfireCode (0xA0) // "Requested AID not present on PICC";
#define TSHRW_DESFIRE_APPLICATION_INTEGRITY_ERROR    DesfireCode (0xA1) // "Unrecoverable error withing application, application will be disabled";
#define TSHRW_DESFIRE_AUTHENTICATION_STATUS_ERROR    DesfireCode (0xAE) // "Current authentication status does not allow the requested command";
#define TSHRW_DESFIRE_ADDITIONAL_FRAME               DesfireCode (0xAF) // "Internal error, additonal data frame is expected to be sent";
#define TSHRW_DESFIRE_BOUNDARY_ERROR                 DesfireCode (0xBE) // "Attempt to read/write data from/to beyond the file's limits";
#define TSHRW_DESFIRE_PICC_INTEGRITY_ERROR           DesfireCode (0xC1) // "Unrecoverable error in card, card will be disabled";
#define TSHRW_DESFIRE_COMMAND_ABORTED                DesfireCode (0xCA) // "Previous command was not fully completed. Not all frames were requested or provided by the PCD";
#define TSHRW_DESFIRE_PICC_DISABLED_ERROR            DesfireCode (0xCD) // "Card was disabled by an unrecoverable error";
#define TSHRW_DESFIRE_APPLICATION_COUNT_ERROR        DesfireCode (0xCE) // "Max. number of applications reached. Number of applications limited to 28";
#define TSHRW_DESFIRE_DUPLICATE_NUMBER_ERROR         DesfireCode (0xDE) // "Duplicate application/file number given";
#define TSHRW_DESFIRE_EEPROM_ERROR                   DesfireCode (0xEE) // "Internal error, EEProm could not be written";
#define TSHRW_DESFIRE_FILE_NOT_FOUND                 DesfireCode (0xF0) // "File not found";
#define TSHRW_DESFIRE_FILE_INTEGRITY_ERROR           DesfireCode (0xF1) // "Unrecoverable error in file";
// Desfire errors according to ISO 7816, generated by card
#define TSHRW_DESFIRE_ISO7816_BOUNDARY_ERROR         DesfireCode (0x6282) // "End of file reached before reading all wished bytes";
#define TSHRW_DESFIRE_ISO7816_WRONG_LENGTH           DesfireCode (0x6700) // "Internal error, wrong length";
#define TSHRW_DESFIRE_ISO7816_NO_FILE_ACCESS         DesfireCode (0x6982) // "File access not allowed";
#define TSHRW_DESFIRE_ISO7816_FILE_EMPTY             DesfireCode (0x6985) // "File empty";
#define TSHRW_DESFIRE_ISO7816_WRONG_PARAMETER        DesfireCode (0x6a86) // "Internal error, wrong parameter P1 and/or P2";
#define TSHRW_DESFIRE_ISO7816_WRONG_PARAMETER2       DesfireCode (0x6a82) // "Internal error, wrong parameter P1 and/or P2";
#define TSHRW_DESFIRE_ISO7816_FILE_NOT_FOUND         DesfireCode (0x6c00) // "File not found";
#define TSHRW_DESFIRE_ISO7816_UNKNOWN_ERROR          DesfireCode (0x6f00) // "No precise diagnostics";
// SDK specific Desfire errors
#define TSHRW_DESFIRE_KEY_LENGTH_NOT_16_BYTES        DesfireCode (0x20) // "Key length is not 16 bytes"
#define TSHRW_DESFIRE_OLD_KEY_LENGTH_NOT_16_BYTES    DesfireCode (0x21) // "Old key length is not 16 bytes"
#define TSHRW_DESFIRE_KRYPT_3K3DES_NOT_SUPPORTED     DesfireCode (0x22) // "Cryptmethod 3K3DES not supported"
#define TSHRW_DESFIRE_AUTHENTICATION_MISSING         DesfireCode (0x23) // "Command needs authentication";
#define TSHRW_DESFIRE_MAC_DOES_NOT_MATCH_DATA        DesfireCode (0x24) // "MAC does not match data"
#define TSHRW_DESFIRE_CRC_DOES_NOT_MATCH_DATA        DesfireCode (0x25) // "CRC after decryption does not match data"
#define TSHRW_DESFIRE_PARAMETER_FIELD_TOO_SMALL      DesfireCode (0x26) // "Length of parameter buffer smaller than data"
#define TSHRW_DESFIRE_INVALID_PARA_LENGTH            DesfireCode (0x27) // "Length of parameter field not valid"
#define TSHRW_DESFIRE_NOT_ALLOWED_AFTER_AUTH_ISO     DesfireCode (0x28) // "Not allowed after authentification with Authenticate ISO or Authenticate AES"

// Error codes NFC (Near Field Communication)
#define NfcErrCode(Code)                             (0x20000 + Code)  // identifier for NFC status/error
#define TSHRW_NFC_NO_OR_UNSUPPORTED_TAG              NfcErrCode (0x01) // "No transponder or transponder type is not supported in funktions for NFC"
#define TSHRW_NFC_UNSUPPORTED_MIFARE_TAG             NfcErrCode (0x02) // "This Mifare transponder type is not supported in funktions for NFC"
#define TSHRW_NFC_ERROR_TAG_TYPE_NOT_DESFIRE         NfcErrCode (0x03) // "Transponder is not of type DESFire"
#define TSHRW_NFC_NOT_NFC_FORMATTED                  NfcErrCode (0x04) // "Transponder is not NFC formated"
#define TSHRW_NFC_ERR_AT_MIFARE_CLASSIC_AUTHENTICATE NfcErrCode (0x05) // "Authentication of MifareClassic transponder failed"
#define TSHRW_NFC_AUTHENT_DESFIRE_CARD_FAILED        NfcErrCode (0x06) // "Authentication of DESFire card level failed"
#define TSHRW_NFC_AUTHENT_DESFIRE_NFC_APP_FAILED     NfcErrCode (0x07) // "Authentication of DESFire NFC application level failed"
#define TSHRW_NFC_ERROR_AT_CHANGING_SETTINGS         NfcErrCode (0x08) // "Error at changing settings"
#define TSHRW_NFC_ERROR_AT_CHANGING_KEY              NfcErrCode (0x09) // "Error at changing key"
#define TSHRW_NFC_ERROR_AT_ISO15693_BLOCK_LOCKING    NfcErrCode (0x0A) // "Error at locking of blocks in ISO15693 transponder"
#define TSHRW_NFC_ERROR_AT_NFC_FORMATTING            NfcErrCode (0x0B) // "Error at formating transponder as NFC"
#define TSHRW_NFC_ERROR_NEWER_VERSION_NFC            NfcErrCode (0x0C) // "NFC in transponder has newer unsupported version as NFC in SDK"
#define TSHRW_NFC_ERROR_OLDER_VERSION_NFC            NfcErrCode (0x0D) // "NFC in transponder has older unsupported version as NFC in SDK"
#define TSHRW_NFC_WRITE_PROTECTED                    NfcErrCode (0x0E) // "Transponder is write protected"
#define TSHRW_NFC_NFC_READ_PROTECTED                 NfcErrCode (0x0F) // "Transponder is NFC read protected"
#define TSHRW_NFC_NFC_WRITE_PROTECTED                NfcErrCode (0x10) // "Transponder is NFC write protected"
#define TSHRW_NFC_ERROR_AT_BLOCK_READING             NfcErrCode (0x11) // "Error at reading of blocks"
#define TSHRW_NFC_ERROR_AT_BLOCK_WRITING             NfcErrCode (0x12) // "Error at writing of blocks"
#define TSHRW_NFC_ERROR_AT_FILE_WRITING              NfcErrCode (0x13) // "Error at writing in DESFire file"
#define TSHRW_NFC_NOT_ENOUGH_FREE_TAG_MEMORY         NfcErrCode (0x14) // "Transponder has not enough free memory for this action"
#define TSHRW_NFC_ID_OF_NFC_APP_NOT_FOUND            NfcErrCode (0x15) // "ID of DESFire NFC application not found"
#define TSHRW_NFC_IS_NFC_WITHOUT_DATA                NfcErrCode (0x16) // "Transponder is NFC formated, but has no user data"
#define TSHRW_NFC_ERROR_IN_NFC_DATA                  NfcErrCode (0x17) // "Error in NFC structure"
#define TSHRW_NFC_ERROR_IN_URL                       NfcErrCode (0x18) // "Error in user data of type URL"
#define TSHRW_NFC_ERROR_IN_MIME                      NfcErrCode (0x19) // "Error in user data of type MIME"
#define TSHRW_NFC_ERROR_IN_JSON                      NfcErrCode (0x1A) // "Error in given JSON-String"
#define TSHRW_NFC_UNKNOWN_USER_DATA_TYPE             NfcErrCode (0x1B) // "Transponder is NFC formated and has userdata of unknown type"
#define TSHRW_NFC_USER_DATA_NOT_OF_TYPE_URL          NfcErrCode (0x1C) // "Transponder has NFC user data but not of type URL"
#define TSHRW_NFC_USER_DATA_NOT_OF_TYPE_TEXT         NfcErrCode (0x1D) // "Transponder has NFC user data but not of type Text"

// Defines zum anhngen falls kein UID
#define _MYD1    0x100
#define _ICODE2  0x200
#define _TAGIT2  0x400
#define _E_MARIN 0x800
#define _STM     0x1000
#define _FUJITSU 0x2000
#define _KSW     0x4000

// ISO Request flags
#define ISO15693_TWO_SUBCARRIER_FLAG    0x01
#define ISO15693_HIGH_DATARATE_FLAG     0x02
#define ISO15693_INVENTORY_FLAG         0x04
#define ISO15693_PROTOKOLL_EXTENSION    0x08 

// ISO Request non inventory table
#define ISO15693_SELECT_FLAG            0x10
#define ISO15693_ADDRESS_FLAG           0x20
#define ISO15693_OPTION_FLAG            0x40

// ISO Request inventory table
#define ISO15693_AFI_FLAG               0x10
#define ISO15693_SINGLE_SLOT_FLAG       0x20
//#define OPTION_FLAG    0x40 (gilt fr inventory und non inventory table)

// Manufacturer Codes
#define ISO15693_MFG_CODE_STM           0x02   // ST Microelectronics
#define ISO15693_MFG_CODE_PHILIPS       0x04   // Philips
#define ISO15693_MFG_CODE_INFINEON      0x05   // Infineon
#define ISO15693_MFG_CODE_TI            0x07   // Texas Instruments
#define ISO15693_MFG_CODE_FUJITSU       0x08   // Fujitsu
#define ISO15693_MFG_CODE_INSIDE        0x12   // Inside Technology France
#define ISO15693_MFG_CODE_ATMEL         0x15   // ATMEL France
#define ISO15693_MFG_CODE_EM            0x16   // Electro Marin
#define ISO15693_MFG_CODE_KSW           0x17   // KSW Mikrotec
#define ISO15693_MFG_CODE_SIC           0x39   // Silicon Craft Thailand
#define ISO15693_MFG_CODE_HID           0x3D   // HID Global USA

#define IGNORE_AUTOMATIC_FLAGS          0x8000


// Parameter fr Mifare Kommandos
#define MIFARE_AUTH_A                   0x00
#define MIFARE_AUTH_B                   0x01

#define DEC_VALUE                       0x00
#define INC_VALUE                       0x01

// Parameter fr Desfire Kommandos
// CryptoMethod:
#define DESFIRE_CM_3DES_DF4             0x00	// Crypt Mode Tripple DES for DESFire4 ICs
#define DESFIRE_CM_3DES_ISO             0x01	// Crypt Mode Tripple DES for DESFire8 ICs
#define DESFIRE_CM_3K3DES               0x40	// Crypt Mode 3 Key Tripple DES for DESFire8 ICs
#define DESFIRE_CM_AES                  0x80	// Crypt Mode AES for DESFire8 ICs
#define DESFIRE_CM_UNKNOWN              0xFF	// Crypt Mode unknown

// Parameter fr SAM Access
#define KEY_TYPE_AES128                 0x0000
#define KEY_TYPE_AES192                 0x0001
#define KEY_TYPE_AES256                 0x0002
#define KEY_TYPE_DES                    0x0003
#define KEY_TYPE_2KTDES                 0x0004
#define KEY_TYPE_3KTDES                 0x0005
#define KEY_TYPE_MIFARE                 0x0006
#define SAM_MODE_AV1                    0x0100

#define DIV_MODE_DESFIRE       0x0000U /**< DESFire Key Diversification. */
#define DIV_MODE_MIFARE_PLUS   0x0001U /**< MIFARE Plus Key Diversification. */
#define DIV_MODE_MASK          0x00FFU /**< Bitmask for diversification Mode. */
#define DIV_OPTION_2KTDES_FULL 0x0000U /**< Option for 2K3DES full-key diversification (only with #PH_CRYPTOSYM_DIV_MODE_DESFIRE). */
#define DIV_OPTION_2KTDES_HALF 0x8000U /**< Option for 2K3DES half-key diversification (only with #PH_CRYPTOSYM_DIV_MODE_DESFIRE). */



// Rckgabewerte
#define TSHRW_RETVAL_ERROR                -1
#define TSHRW_RETVAL_OK                   0

#ifdef __cplusplus
extern "C"
{
#endif

#ifdef _EXPORT
#define _DECL __declspec(dllexport)
#else
#ifdef _HRW_LIB
#define _DECL
#else
#define _DECL __declspec(dllimport)
#endif
#endif

_DECL int __stdcall TSHRW_LibVersion(void);
_DECL int __stdcall TSHRW_IsVirtualComInstalled(void);

_DECL int __stdcall TSHRW_IsDeviceDriverMissing(void);

_DECL int __stdcall TSHRW_CountAllDevices();
_DECL int __stdcall TSHRW_ListAllDeviceNames(char* NamenListe, int nBufferSize);
_DECL int __stdcall TSHRW_ListAllDeviceNamesEx(char* NamenListe, int nBufferSize);
_DECL int __stdcall TSHRW_GetAvailablePorts(char* NamenListe, int nBufferSize);

_DECL int __stdcall TSHRW_LanListAllDeviceNames(char* NamenListe, int nBufferSize);
_DECL int __stdcall TSHRW_LanConfigListDevices(char* Buffer, int nBufferSize);

_DECL int __stdcall TSHRW_LanChangeIPAddress(LPCSTR OldAddress, LPCSTR NewAddress, LPCSTR IPMask);
_DECL int __stdcall TSHRW_LanChangeIPAddressEx(LPCSTR OldAddress, LPCSTR NewAddress, LPCSTR IPMask, LPCSTR GatewayAddress);
_DECL int __stdcall TSHRW_LanGetIPAddressEx(LPCSTR strName, char * Address, char * IPMask, char * GatewayAddress);
_DECL int __stdcall TSHRW_LanGetInfo(LPCSTR strName, char * DHCPName, char * IPAddress, char * IPMask, char * GatewayAddress);
_DECL int __stdcall TSHRW_LanGetRemoteIPAndPort(LPCSTR strName, char * pIPAddress, int MaxIPLen, int * pPortNr);
_DECL int __stdcall TSHRW_LanWriteRemoteIPAndPort(LPCSTR strName, const char * pIPAddress, int PortNr);

_DECL int __stdcall TSHRW_LanIsDeviceAvailable(LPCSTR Address);

_DECL int __stdcall TSHRW_LanConfigOpen(LPCSTR strName);
_DECL int __stdcall TSHRW_LanConfigGet(int nHandle, int RecordNr,       BYTE * pData, int Len);
_DECL int __stdcall TSHRW_LanConfigSet(int nHandle, int RecordNr, const BYTE * pData,int Len);
_DECL int __stdcall TSHRW_LanConfigClose(int nHandle,int Reset);

_DECL int __stdcall TSHRW_HIDConfigRead(int PortHandle, BYTE * pSendBuf, int SendBufLen,BYTE * pRecvBuf, int RecvBufLen);
_DECL int __stdcall TSHRW_HIDConfigWrite(int PortHandle, BYTE * pSendBuf, int SendBufLen);

_DECL int __stdcall TSHRW_BT_SetPin (int PortHandle,const char * Pin);
_DECL int __stdcall TSHRW_BT_GetPin (int PortHandle,char * Pin);
_DECL int __stdcall TSHRW_BT_SetLocalName(int PortHandle, const char * LocalName);
_DECL int __stdcall TSHRW_BT_GetLocalName(int PortHandle, char * LocalName);
_DECL int __stdcall TSHRW_BT_GetLocalBTAddr(int PortHandle, BYTE * LocalAddr);
_DECL int __stdcall TSHRW_BT_SetOperationMode(int PortHandle, int Mode);
_DECL int __stdcall TSHRW_BT_GetOperationMode(int PortHandle, int * pMode);
_DECL int __stdcall TSHRW_BT_SetValidPorts(int PortHandle, int Ports);
_DECL int __stdcall TSHRW_BT_GetValidPorts(int PortHandle, int * pPorts);
_DECL int __stdcall TSHRW_BT_SetEventFilter(int PortHandle, int Filter);
_DECL int __stdcall TSHRW_BT_GetEventFilter(int PortHandle, int * pFilter);
_DECL int __stdcall TSHRW_BT_SetDeviceClass(int PortHandle, int DevClass);
_DECL int __stdcall TSHRW_BT_ChangeUARTSpeed(int PortHandle, int SpeedIdx);

_DECL int __stdcall TSHRW_BT_ListAllDeviceNames(char* Buffer, int nBufferSize);
_DECL int __stdcall TSHRW_BT_Search (int PortHandle, BYTE * DeviceList, int nBufferSize, int Timeout , DWORD ClassFilter);
_DECL int __stdcall TSHRW_BT_Connect(int PortHandle, BYTE * Device, BYTE RemotePortNr, int Timeout);
_DECL int __stdcall TSHRW_BT_CheckConnection(int PortHandle);
_DECL int __stdcall TSHRW_BT_Disconnect(int PortHandle);

_DECL int __stdcall TSHRW_OpenPort(LPCSTR Name,int Baudrate,int Timeout);
_DECL int __stdcall TSHRW_ClosePort(int handle);
_DECL int __stdcall TSHRW_GetPortName(int handle, char * pName, int MaxLen);

_DECL int __stdcall TSHRW_KeepAppActive(int handle,int bActive);

typedef int (__stdcall * TSHRW_TRACEFCT)(int handle, LPCSTR str);
_DECL int __stdcall TSHRW_SetTrace(TSHRW_TRACEFCT fct);
_DECL int __stdcall TSHRW_GiSTrace(int handle, LPCSTR str);

_DECL int __stdcall TSHRW_SetReaderAdresse(int handle,int Adresse);

typedef int(__stdcall* AutoReadCallback)(char * pData, int Len);
_DECL int __stdcall TSHRW_StartAutoRead(int handle, int TermChar, AutoReadCallback pAutoReadProc);
_DECL int __stdcall TSHRW_StopAutoRead(int handle);

_DECL int __stdcall TSHRW_DeviceVersion(int PortHandle, BYTE * pBuffer, int BufLen);
_DECL int __stdcall TSHRW_GetDeviceName(int PortHandle, char * pDevName, int NameLen);
_DECL int __stdcall TSHRW_IsProgrammer(int PortHandle);
_DECL int __stdcall TSHRW_IsReader(int PortHandle);

_DECL int __stdcall TSHRW_IsUSB(int handle);
_DECL int __stdcall TSHRW_SetBaudrate(int handle, int Baudrate, int ParityMode);
_DECL int __stdcall TSHRW_SetReaderMode(int handle,int mode);
_DECL int __stdcall TSHRW_SetRF(int handle,int OnOff);
_DECL int __stdcall TSHRW_SetIO(int handle,int Maske, int OutWert);
_DECL int __stdcall TSHRW_ReadIO(int handle);

_DECL int __stdcall TSHRW_SetLED(int handle, int red, int green, int yellow);
_DECL int __stdcall TSHRW_Beep(int handle);

_DECL int __stdcall TSHRW_GetLastError(int handle);
_DECL int __stdcall TSHRW_GetLastErrorMessage(int handle, int language, char* pMessageBuffer, int MessageBufferLen);

_DECL int __stdcall TSHRW_ReadSerialNumber(int handle, BYTE * pSerial, int Buflen);
_DECL int __stdcall TSHRW_SetConfig(int handle,BYTE * pConfig, int ConfigLen);
_DECL int __stdcall TSHRW_GetConfig(int handle,BYTE * pConfig, int ConfigLen);
_DECL int __stdcall TSHRW_SetDefault(int handle);

_DECL int __stdcall TSHRW_GetActivationContext(int handle, char * pData, int Len);
_DECL int __stdcall TSHRW_WriteActivationContext(int handle, const char * pData, int Len);
_DECL int __stdcall TSHRW_ReadCounter(int handle, int * pCounter);
_DECL int __stdcall TSHRW_DecrementCounter(int handle, int * pNewCounter);
_DECL int __stdcall TSHRW_GetDaysRemain(int handle, int * pDaysRemain);
_DECL int __stdcall TSHRW_UpdateDaysRemain(int handle, int * pDaysRemain);

_DECL int __stdcall TSHRW_SetCommunicationMode(int handle, int Mode);

_DECL int __stdcall TSHRW_RawWrite(int handle,BYTE * pBuffer, int BufLen);
_DECL int __stdcall TSHRW_RawRead(int handle,BYTE * pBuffer, int BufLen);
_DECL int __stdcall TSHRW_Transfer(int PortHandle, BYTE * pSendBuf, int SendBufLen,BYTE * pRecvBuf, int RecvBufLen);

_DECL int __stdcall TSHRW_ReadRegister(int handle, int Register, BYTE *pVal);
_DECL int __stdcall TSHRW_WriteRegister(int handle, int Register, BYTE Val);

_DECL int __stdcall TSHRW_ReadEEProm(int handle, int StartAdresse, BYTE * pData, int Len);
_DECL int __stdcall TSHRW_WriteEEProm(int handle, int StartAdresse, const BYTE * pData, int Len);

_DECL int __stdcall TSHRW_ISO_Inventory(int handle,BYTE * pBuffer,int BufLen,int nRequestFlag);
_DECL int __stdcall TSHRW_ISO_InventoryAFI(int handle,BYTE * pBuffer,int BufLen,int nRequestFlag,int AFI);
_DECL int __stdcall TSHRW_ISO_GetSystemInfo(int handle,BYTE * pBuffer,int BufLen, BYTE * pUID, int UIDLen,int nRequestFlag);
_DECL int __stdcall TSHRW_ISO_ReadSingleBlock(int handle,int nBlock,BYTE * pBuffer,int BufLen,BYTE * pUID,int UIDLen,int nRequestFlag);
_DECL int __stdcall TSHRW_ISO_ReadMultipleBlocks(int handle,int nFirstBlock,int nNumberOfBlocks,BYTE * pBuffer,int BufLen,BYTE * pUID,int UIDLen,int nRequestFlag);
_DECL int __stdcall TSHRW_ISO_WriteSingleBlock(int handle,int nBlock,BYTE * pBuffer,int BufLen,BYTE * pUID,int UIDLen,int nRequestFlag);
_DECL int __stdcall TSHRW_ISO_SetAirProtokoll(int handle,int nAirSettings);
_DECL int __stdcall TSHRW_ISO_GetAirProtokoll(int handle,int * nAirSettings);
_DECL int __stdcall TSHRW_ISO_GetTagInfo(int handle,BYTE * pUID, int UIDLen,int* BlockAnzahl,int* BytesProBlock,int* MfgCode,int nRequestFlag);
_DECL int __stdcall TSHRW_ISO_LockBlock(int handle,int nBlock,BYTE * pUID,int UIDLen,int nRequestFlag);
_DECL int __stdcall TSHRW_ISO_StayQuiet(int handle,BYTE * pUID,int UIDLen,int nRequestFlag);
_DECL int __stdcall TSHRW_ISO_Select(int handle,BYTE * pUID,int UIDLen,int nRequestFlag);
_DECL int __stdcall TSHRW_ISO_ResetToReady(int handle,BYTE * pUID,int UIDLen,int nRequestFlag);
_DECL int __stdcall TSHRW_ISO_GetMultipleBlockSecurityStatus(int handle,int nFirstBlock,int nNumberOfBlocks,BYTE * pBuffer,int BufLen,BYTE * pUID,int UIDLen,int nRequestFlag);
_DECL int __stdcall TSHRW_ISO_WriteAFI(int handle,int AFI,BYTE * pUID,int UIDLen,int nRequestFlag);
_DECL int __stdcall TSHRW_ISO_LockAFI(int handle,BYTE * pUID,int UIDLen,int nRequestFlag);
_DECL int __stdcall TSHRW_ISO_WriteDSFID(int handle,int DSFID,BYTE * pUID,int UIDLen,int nRequestFlag);
_DECL int __stdcall TSHRW_ISO_LockDSFID(int handle,BYTE * pUID,int UIDLen,int nRequestFlag);
_DECL int __stdcall TSHRW_ISO_RawRequest(int handle,int nRequestFlag, int nKommando, BYTE * pParam, int nParamLen, BYTE * pData, int nDataLen,BYTE * pReceive, int nReceiveLen);

_DECL int __stdcall TSHRW_WriteTiming(int handle,int nTiming);
_DECL int __stdcall TSHRW_SetComparator(int handle,BYTE * pParam, int nParamLen);

_DECL int __stdcall TSHRW_Mifare_Request(int handle,WORD *pATQA);
_DECL int __stdcall TSHRW_Mifare_RequestAll(int handle,WORD *pATQA);
_DECL int __stdcall TSHRW_Mifare_Select(int handle, BYTE * pUID, int nUIDLen, BYTE * pSAK);
_DECL int __stdcall TSHRW_Mifare_SelectUID(int handle, BYTE * pUID, int nUIDLen, BYTE * pSAK);
_DECL int __stdcall TSHRW_Mifare_Halt(int handle);
_DECL int __stdcall TSHRW_MifareSetKey(int handle, int KeyType, int nAdresse, BYTE * pKey, int nKeyLen);
_DECL int __stdcall TSHRW_MifareAuthenticate(int handle, BYTE * pUID, int nUIDLen, int KeyType, int nAdresse, int BlockNr);
_DECL int __stdcall TSHRW_MifareAuthenticateDirect(int handle, BYTE * pUID, int nUIDLen, int KeyType, BYTE * pKey, int nKeyLen, int BlockNr);
_DECL int __stdcall TSHRW_MifareRead       (int handle, int BlockNr, BYTE * pData, int nDataLen);
_DECL int __stdcall TSHRW_MifareWrite      (int handle, int BlockNr, BYTE * pData, int nDataLen);
_DECL int __stdcall TSHRW_MifareGetValue   (int handle, int BlockNr, int *pValue);
_DECL int __stdcall TSHRW_MifareSetValue   (int handle, int BlockNr, int Value);
_DECL int __stdcall TSHRW_MifareChangeValue(int handle, int BlockNr, int Richtung, int Differenz);
_DECL int __stdcall TSHRW_ISO14443SetCID   (int handle, int CID);
_DECL int __stdcall TSHRW_ISO14443Rats     (int handle, BYTE * pData, int  MaxDataLen);
_DECL int __stdcall TSHRW_ISO14443PPS      (int handle, int Speed);

_DECL int __stdcall TSHRW_ISO14443B_Transmit(int handle, BYTE *pSendData, int nSendLen, BYTE * pRecvData, int RecvLen);
_DECL int __stdcall TSHRW_ISO14443B_Request (int handle, BYTE * pUID, int UIDLen, BYTE * pAppData, int AppDataLen, BYTE * pProtocolInfo, int ProtocolInfoLen);
_DECL int __stdcall TSHRW_ISO14443B_Wakeup  (int handle, BYTE * pUID, int UIDLen, BYTE * pAppData, int AppDataLen, BYTE * pProtocolInfo, int ProtocolInfoLen);
_DECL int __stdcall TSHRW_ISO14443B_Select  (int handle, int Speed, BYTE * pUID, int UIDLen);

_DECL int __stdcall TSHRW_ISO14443Transmit (int handle, BYTE *pSendData, int nSendLen, BYTE * pRecvData, int RecvLen);

_DECL int __stdcall TSHRW_Desfire_GetVersion(int handle, BYTE* pVersionData, int VersionDataLen);
_DECL int __stdcall TSHRW_Desfire_GetFreePICCMemory(int handle);
_DECL int __stdcall TSHRW_Desfire_FormatPICC(int handle);
_DECL int __stdcall TSHRW_Desfire_GetCardUID(int handle, BYTE* pUID, int UIDBuffLen);
_DECL int __stdcall TSHRW_Desfire_SetConfiguration(int handle, BYTE Option, BYTE* pSettings, int SettingsLen);
_DECL int __stdcall TSHRW_Desfire_Authenticate(int handle, BYTE KeyNo, BYTE* pKey, int KeySize);
_DECL int __stdcall TSHRW_Desfire_AuthenticateIso(int handle, BYTE KeyNo, BYTE* pKey, int KeySize);
_DECL int __stdcall TSHRW_Desfire_AuthenticateAES(int handle, BYTE KeyNo, BYTE* pKey, int KeySize);
_DECL int __stdcall TSHRW_Desfire_GetKeySettings(int handle, BYTE* pKeySettings, int KeySettingsLen);
_DECL int __stdcall TSHRW_Desfire_ChangeKeySettings(int handle, BYTE ChangeKeyAuthentWith, BYTE OtherKeySettings);
_DECL int __stdcall TSHRW_Desfire_ChangeKey(int handle, BYTE KeyNo, BYTE* pNewKey, int NewKeyLen, BYTE NewKeyVersion, BYTE* pCurrentKey, int CurrentKeyLen, BYTE NewMasterKeyCrypto);
_DECL int __stdcall TSHRW_Desfire_GetKeyVersion(int handle, BYTE KeyNo);
_DECL int __stdcall TSHRW_Desfire_GetApplicationIdsAndNames(int handle, BYTE* pAppNamesArray, int AppNamesArrayLen);
_DECL int __stdcall TSHRW_Desfire_GetApplicationIds(int handle, BYTE* pAppIds, int AppIdsLen);
_DECL int __stdcall TSHRW_Desfire_SelectApplication(int handle, int AppId);
_DECL int __stdcall TSHRW_Desfire_CreateApplication(int handle, int AppId, BYTE KeyCrypto, BYTE MaxNoOfKeys, int bFilesWithIsoID, BYTE ChangeKeyAuthentWith, BYTE OtherKeySettings, BYTE* pIso7816Data, int Iso7816DataLen);
_DECL int __stdcall TSHRW_Desfire_DeleteApplication(int handle, int AppId);
_DECL int __stdcall TSHRW_Desfire_GetFileIds(int handle, BYTE* pFileIds, int FileIdsLen);
_DECL int __stdcall TSHRW_Desfire_GetFileIsoIds(int handle, BYTE* pFileIds, int FileIdsLen);
_DECL int __stdcall TSHRW_Desfire_GetFileSettings(int handle, int FileId, BYTE* pFileSettings, int FileSettingsBufferLen);
_DECL int __stdcall TSHRW_Desfire_ChangeFileSettings(int handle, int FileId, int bChangeAccessRightsFree, BYTE* pFileSettings, int FileSettingsLen);
_DECL int __stdcall TSHRW_Desfire_CreateStandardDataFile(int handle, BYTE FileId, int IsoFileId, int FileSize, BYTE CommunicationMode, int AccessRights);
_DECL int __stdcall TSHRW_Desfire_CreateBackupDataFile(int handle, BYTE FileId, int IsoFileId, int FileSize, BYTE CommunicationMode, int AccessRights);
_DECL int __stdcall TSHRW_Desfire_CreateValueFile(int handle, BYTE FileId, BYTE CommunicationMode, int AccessRights, unsigned int LowerLimit, unsigned int UpperLimit, unsigned int InitialValue, BYTE Config);
_DECL int __stdcall TSHRW_Desfire_CreateLinearRecordFile(int handle, BYTE FileId, int IsoFileId, BYTE CommunicationMode, int AccessRights, int RecordSize, int MaxCountRecords);
_DECL int __stdcall TSHRW_Desfire_CreateCyclicRecordFile(int handle, BYTE FileId, int IsoFileId, BYTE CommunicationMode, int AccessRights, int RecordSize, int MaxCountRecords);
_DECL int __stdcall TSHRW_Desfire_DeleteFile(int handle, BYTE FileId);
_DECL int __stdcall TSHRW_Desfire_ReadData(int PortHandle, BYTE FileId, BYTE CommunicationMode, int StartIndex, int ReadCount, BYTE* pReadData, int ReadDataBufferLen);
_DECL int __stdcall TSHRW_Desfire_WriteData(int PortHandle, BYTE FileId, BYTE CommunicationMode, int OffsetInFile, BYTE* pWriteData, int WriteDataLen);
_DECL int __stdcall TSHRW_Desfire_GetValue(int handle, BYTE FileId, BYTE CommunicationMode, unsigned int * pValue);
_DECL int __stdcall TSHRW_Desfire_Credit(int handle, BYTE FileId, BYTE CommunicationMode, unsigned int Value);
_DECL int __stdcall TSHRW_Desfire_LimitedCredit(int handle, BYTE FileId, BYTE CommunicationMode, unsigned int Value);
_DECL int __stdcall TSHRW_Desfire_Debit(int handle, BYTE FileId, BYTE CommunicationMode, unsigned int Value);
_DECL int __stdcall TSHRW_Desfire_ReadRecord(int PortHandle, BYTE FileId, BYTE CommunicationMode, int StartRecord, int ReadCountRecords, int RecordSize, BYTE* pReadData, int ReadDataBufferLen);
_DECL int __stdcall TSHRW_Desfire_WriteRecord(int PortHandle, BYTE FileId, BYTE CommunicationMode, int OffsetInRecord, BYTE* pWriteData, int WriteDataLen);
_DECL int __stdcall TSHRW_Desfire_ClearRecordFile(int handle, int FileId);
_DECL int __stdcall TSHRW_Desfire_CommitTransaction(int handle);
_DECL int __stdcall TSHRW_Desfire_AbortTransaction(int handle);
_DECL int __stdcall TSHRW_Desfire_IsoSelectApplication(int PortHandle, BYTE* pAppName, int AppNameLen);
_DECL int __stdcall TSHRW_Desfire_IsoSelectFile(int PortHandle, int IsoFileId);
_DECL int __stdcall TSHRW_Desfire_IsoReadData(int PortHandle, int StartIndex, int ReadCount, BYTE* pReadData, int ReadDataBufferLen);
_DECL int __stdcall TSHRW_Desfire_IsoWriteData(int PortHandle, int StartIndex, BYTE* WriteData, int WriteDataLen);
_DECL int __stdcall TSHRW_DesfireISO7816EnableWrapping (int PortHandle, int bOn);

_DECL int __stdcall TSHRW_Nfc_ReadTag(int PortHandle, char* pReadData, int ReadDataLen);
_DECL int __stdcall TSHRW_Nfc_ReadUrl(int PortHandle, char* pUrl, int UrlLen, char* pText, int TextLen);
_DECL int __stdcall TSHRW_Nfc_ReadText(int PortHandle, char* pText, int TextLen);
_DECL int __stdcall TSHRW_Nfc_ReadTagUid(int PortHandle, BYTE* pReadData, int ReadDataLen);
_DECL int __stdcall TSHRW_Nfc_WriteTag(int PortHandle, char* pWriteData, int WriteDataLen, BYTE* pKey, int Keylen, int Lock);
_DECL int __stdcall TSHRW_Nfc_WriteUrl(int PortHandle, char* pUrl, int UrlLen, char* pText, int TextLen, BYTE* pKey, int Keylen, int Lock);
_DECL int __stdcall TSHRW_Nfc_WriteText(int PortHandle, char* pText, int TextLen, BYTE* pKey, int Keylen, int Lock);
_DECL int __stdcall TSHRW_Nfc_FormatTag(int PortHandle, BYTE* pKey, int Keylen);
_DECL int __stdcall TSHRW_Nfc_LockTag(int PortHandle, BYTE* pKey, int Keylen);
_DECL int __stdcall TSHRW_Nfc_SetTagPasswordProtected(int PortHandle, int bUserDataToo, BYTE* pOldKey, int OldKeylen, BYTE* pNewKey, int NewKeylen);

_DECL int __stdcall TSHRW_WriteParam(int handle,BYTE * pBuffer, int BufLen);
_DECL int __stdcall TSHRW_ReadParam(int handle,BYTE * pBuffer, int BufLen);
_DECL int __stdcall TSHRW_WritePrefix(int handle,BYTE * pBuffer, int BufLen);
_DECL int __stdcall TSHRW_ReadPrefix(int handle,BYTE * pBuffer, int BufLen);
_DECL int __stdcall TSHRW_WriteSuffix(int handle,BYTE * pBuffer, int BufLen);
_DECL int __stdcall TSHRW_ReadSuffix(int handle,BYTE * pBuffer, int BufLen);
_DECL int __stdcall TSHRW_WriteTermix(int handle,BYTE * pBuffer, int BufLen);
_DECL int __stdcall TSHRW_ReadTermix(int handle,BYTE * pBuffer, int BufLen);
_DECL int __stdcall TSHRW_WritePostcode(int handle,BYTE * pBuffer, int BufLen);
_DECL int __stdcall TSHRW_ReadPostcode(int handle,BYTE * pBuffer, int BufLen);
_DECL int __stdcall TSHRW_WriteReadModeParam(int handle,BYTE * pBuffer, int BufLen);
_DECL int __stdcall TSHRW_ReadReadModeParam(int handle,BYTE * pBuffer, int BufLen);
_DECL int __stdcall TSHRW_WriteMifareKey(int handle, int KeyType, BYTE * pKey, int KeyLen);

#ifdef __cplusplus
}
#endif

#endif // TS_HRW_IMPORT_INCLUDED_
